#!/bin/bash

#Inicialització variables usuari
APIKEY= #write your api key here
feed_export_kwh=16 #write your feed_export_id here
feed_import_vall=17
feed_import_pic=18

Preu_pic=0.18696394 #Write your electricity costs here
Preu_vall=0.09538977
Preu_injeccio=0.06359318

#Càlcul del timestamp actual i del primer dia del mes, en milisegons
ara=$(date '+%s')
let ara=$ara*1000
dia1=$(date -d `date +%Y-%m-%d` +%Y-%m-01)
dia1_s=$(date -d$dia1 '+%s')
let dia1_s=$dia1_s*1000
let dia1_s2=$dia1_s+1000

#Crides per obtenir dades
Export_Actual=$(wget -qO- "http://127.0.0.1/feed/value.json?id=$feed_export_kwh&apikey=$APIKEY")
Import_Pic_Actual=$(wget -qO- "http://127.0.0.1/feed/value.json?id=$feed_import_pic&apikey=$APIKEY")
Import_Vall_Actual=$(wget -qO- "http://127.0.0.1/feed/value.json?id=$feed_import_vall&apikey=$APIKEY")
Export_Dia1_temp=$(wget -qO- "http://127.0.0.1/feed/data.json?id=$feed_export_kwh&apikey=$APIKEY&start=$dia1_s&end=$dia1_s2&interval=1")
Import_Vall_Dia1_temp=$(wget -qO- "http://127.0.0.1/feed/data.json?id=$feed_import_vall&apikey=$APIKEY&start=$dia1_s&end=$dia1_s2&interval=1")
Import_Pic_Dia1_temp=$(wget -qO- "http://127.0.0.1/feed/data.json?id=$feed_import_pic&apikey=$APIKEY&start=$dia1_s&end=$dia1_s2&interval=1")

Export_Dia1=$(echo $Export_Dia1_temp | cut -d "," -f 2 | tr -s ']' ' ')
Import_Vall_Dia1=$(echo $Import_Vall_Dia1_temp | cut -d "," -f 2 | tr -s ']' ' ')
Import_Pic_Dia1=$(echo $Import_Pic_Dia1_temp | cut -d "," -f 2 | tr -s ']' ' ')

#Calcul de la factura
Total_mes_injec_llarg=$(echo "($Export_Actual-$Export_Dia1)" | bc)
Total_mes_vall_llarg=$(echo "($Import_Vall_Actual-$Import_Vall_Dia1)" | bc)
Total_mes_pic_llarg=$(echo "($Import_Pic_Actual-$Import_Pic_Dia1)" | bc)

Cost_injec_llarg=$(echo "$Total_mes_injec_llarg*$Preu_injeccio" | bc)
Cost_vall_llarg=$(echo "$Total_mes_vall_llarg*$Preu_vall" | bc)
Cost_pic_llarg=$(echo "$Total_mes_pic_llarg*$Preu_pic" | bc)
Cost_final_llarg=$(echo "$Cost_vall_llarg+$Cost_pic_llarg-$Cost_injec_llarg" | bc)

printf -v Total_mes_injec "%0.2f" $Total_mes_injec_llarg
printf -v Total_mes_vall "%0.2f" $Total_mes_vall_llarg
printf -v Total_mes_pic "%0.2f" $Total_mes_pic_llarg
printf -v Cost_injec "%0.2f" $Cost_injec_llarg
printf -v Cost_vall "%0.2f" $Cost_vall_llarg
printf -v Cost_pic "%0.2f" $Cost_pic_llarg
printf -v Cost_final "%0.2f" $Cost_final_llarg

echo -e "\n Els consums actuals d'aquest mes són de: \n Hores pic: " $Total_mes_pic "kWh\n Hores vall: " $Total_mes_vall "kWh\n Injecció: " $Total_mes_injec "kWh"
echo -e "\n La factura actual d'aquest mes és de: \n Hores pic: " $Cost_pic "€\n Hores vall: " $Cost_vall "€\n Injecció: " $Cost_injec "€"
echo -e "\n Total: " $Cost_final "€"
